var ai_sticky_delay = 50;

function ai_process_sticky_elements ($) {
  var ai_debug = typeof ai_debugging !== 'undefined';
  var client_width = document.documentElement.clientWidth, inner_width =  window.innerWidth;

  var main_element = element = $('.ai-content').first ();
  var default_margin = 0;
  var sticky_content = $('.ai-sticky-content');

  if (ai_debug) console.log ("AI content:", sticky_content.length, 'elements');
  if (ai_debug) console.log ("AI content:", $('.ai-content').length, 'markers');

  var main_width = 0;
  if (sticky_content.length != 0 && element.length != 0) {
    while (element.prop ("tagName") != "BODY") {
      var outer_width = element.outerWidth ();

      if (ai_debug) console.log ("AI content element:", element.prop ("tagName"), element.attr ("id"), element.attr ("class"), outer_width, 'px');

      if (outer_width != 0 && outer_width <= client_width && outer_width >= main_width) {
        main_element = element;
        main_width = outer_width;
      }

      element = element.parent ();
    }
  }

  if (main_width != 0) {
    if (ai_debug) console.log ("AI content client width:", client_width, 'px');
    if (ai_debug) console.log ("AI content main element:", main_element.prop ("tagName"), main_element.attr ("id"), main_element.attr ("class"), main_element.width (), 'px');

    var shift = main_width / 2 + default_margin;

    if (ai_debug) console.log ('AI content shift:', shift, 'px');

    sticky_content.each (function () {
      var block_width = $(this).width ();
      var block_height = $(this).height ();

      if ($(this).hasClass ('ai-sticky-left')) {
        var margin = parseInt ($(this).css ('margin-right'));

        if (ai_debug) console.log ('AI content sticky left  ', $(this).attr ("class"), '=> SPACE LEFT: ', main_element.offset().left - margin - block_width, 'px');

        if (main_element.offset().left - margin - block_width >= - block_width / 2) {
          $(this).css ('left', 'calc(50% - ' + (shift + block_width + margin) + 'px)');
          if (!$(this).hasClass ('ai-sticky-parameters')) $(this).show ();
        } else $(this).removeClass ('ai-sticky-scroll'); // prevent showing if it has sticky scroll class

      } else
      if ($(this).hasClass ('ai-sticky-right')) {
        var margin = parseInt ($(this).css ('margin-left'));

        if (ai_debug) console.log ('AI content sticky right ', $(this).attr ("class"), '=> SPACE RIGHT: ', client_width - (main_element.offset().left + main_width + margin + block_width), 'px');

        if (main_element.offset().left + main_width + margin + block_width <= client_width + block_width / 2) {
          $(this).css ('right', '').css ('left', 'calc(50% + ' + shift + 'px)');
          if (!$(this).hasClass ('ai-sticky-parameters')) $(this).show ();
        } else $(this).removeClass ('ai-sticky-scroll'); // prevent showing if it has sticky scroll class
      }

      if ($(this).hasClass ('ai-sticky-scroll')) {

        if (ai_debug) console.log ('AI content sticky scroll', $(this).attr ("class"), '=> MARGIN BOTTOM:', - block_height, 'px');

        $(this).css ('margin-bottom', - block_height).show ();
      }
    });
  }

  function ai_process_parameters (element, parameters) {
    console.log ("AI PROCESS STICKY PARAMETERS:", parameters, $(element).attr ('class'), $(element).attr ('id'));

    switch (parameters [1]) {
      case 0:
        if (parameters [2] == 0)
          $(element).show (); else
            $(element).fadeIn (parameters [2]);
        break;
    }
  }

  $('.ai-sticky-parameters').each (function () {
    var ai_parameters = atob ($(this).data ('ai-parameters'));
//    var ai_parameters = '[3500,0,0]';
    if (typeof ai_parameters != "undefined") {
      try {
        var parameters = JSON.parse (ai_parameters);
      } catch (error) {
        console.log ("AI STICKY PARAMETERS ERROR:", ai_parameters);
      }

      if (typeof parameters == "object") {
        console.log ("AI STICKY PARAMETERS:", parameters, $(this).attr ('class'), $(this).attr ('id'));

        var delay = parameters [0] - ai_sticky_delay;
        if (delay < 0) delay = 0;
        setTimeout (ai_process_parameters, delay, this, parameters);
      }

    }
  });

}

jQuery(document).ready(function($) {

  console.log ('document ready');

//  ai_process_sticky_elements (jQuery);
  setTimeout (function() {ai_process_sticky_elements (jQuery);}, ai_sticky_delay);

});

