<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

function woocommerce_watermark_options_group() {
	register_setting('woocommerce_watermark_options', 'woocommerce_watermark_enabled_plugin');
    register_setting('woocommerce_watermark_options', 'woocommerce_watermark_img');
    register_setting('woocommerce_watermark_options', 'woocommerce_watermark_img_lg');
    register_setting('woocommerce_watermark_options', 'wt_position');
    register_setting('woocommerce_watermark_options', 'wt_repeat');
    register_setting('woocommerce_watermark_options', 'wt_margin');
    register_setting('woocommerce_watermark_options', 'wt_opacity');
    register_setting('woocommerce_watermark_options', 'wt_color_op');
    register_setting('woocommerce_watermark_options', 'ly_opacity');
    register_setting('woocommerce_watermark_options', 'ly_color_op');
}
 
add_action ('admin_init', 'woocommerce_watermark_options_group');



function ns_update_options_form() {
	$plugin_active = get_option('woocommerce_watermark_enabled_plugin');
	$immagine = get_option('woocommerce_watermark_img');
	$immagine_lg = get_option('woocommerce_watermark_img_lg');
	$wt_position = get_option('wt_position');
	$wt_repeat = get_option('wt_repeat');
	$wt_margin = get_option('wt_margin');
	$wt_opacity = get_option('wt_opacity');
	$wt_color_op = get_option('wt_color_op');
	$ly_opacity = get_option('ly_opacity');
	$ly_color_op = get_option('ly_color_op');
    ?>
       <div class="wrap">
        <div class="icon32" id="icon-options-general"><br /></div>
        <h2>NS WooCommerce Watermark settings</h2>
        <p>&nbsp;</p>
        <form method="post" action="options.php" enctype="multipart/form-data">
            <?php settings_fields('woocommerce_watermark_options'); ?>
            <table class="form-table">
                <tbody>
					<tr valign="top">
					<th scope="row"><label for="woocommerce_watermark_enabled_plugin"><?php _e('Gd Library', 'ns-woocommerce-watermark-premium'); ?>:</label></th>
						<td>
							<?php
								$ns_gd_lib = gd_info();
								if ($ns_gd_lib["GD Version"]) {
									_e('Ok', 'ns-woocommerce-watermark-premium');
								} else {
									_e('Contact your admin server to install gd library on your server', 'ns-woocommerce-watermark-premium');
								}
							?>
						</td>
					</tr>
					<tr valign="top">
					<th scope="row"><label for="woocommerce_watermark_enabled_plugin"><?php _e('Allow url fopen', 'ns-woocommerce-watermark-premium'); ?>:</label></th>
						<td>
							<?php
								if (ini_get("allow_url_fopen") == true) {
									_e('Ok', 'ns-woocommerce-watermark-premium');
								} else {
									_e('Contact your admin server to turn on allow_url_fopen', 'ns-woocommerce-watermark-premium');
								}
							?>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="woocommerce_watermark_enabled_plugin"><?php _e('Enabled Plugin', 'ns-woocommerce-watermark-premium'); ?>:</label></th>
							<td>
								<?php
									$woocommerce_watermark_enabled_plugin0 = (get_option('woocommerce_watermark_enabled_plugin') AND get_option('woocommerce_watermark_enabled_plugin') == 0) ? ' selected="selected"' : '';
									$woocommerce_watermark_enabled_plugin1 = (get_option('woocommerce_watermark_enabled_plugin') AND get_option('woocommerce_watermark_enabled_plugin') == 1) ? ' selected="selected"' : '';
									$woocommerce_watermark_enabled_plugin2 = (get_option('woocommerce_watermark_enabled_plugin') AND get_option('woocommerce_watermark_enabled_plugin') == 2) ? ' selected="selected"' : '';
								?>
								<select name="woocommerce_watermark_enabled_plugin" id="woocommerce_watermark_enabled_plugin">
									<option value="0" <?php echo $woocommerce_watermark_enabled_plugin0; ?>><?php _e('Enable', 'ns-woocommerce-watermark-premium'); ?></option>
									<option value="1" <?php echo $woocommerce_watermark_enabled_plugin1; ?>><?php _e('Disable', 'ns-woocommerce-watermark-premium'); ?></option>
									<option value="2" <?php echo $woocommerce_watermark_enabled_plugin2; ?>><?php _e('Enable only for not registred user', 'ns-woocommerce-watermark-premium'); ?></option>
								</select>
							</td>
						</tr>
                    <tr valign="top">
						<th class="titledesc" scope="row">
							<label for="woocommerce_watermark_img"><?php _e('Select a Watermark', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Select a image from your local folder or from media library', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <img src="<?php echo get_option('woocommerce_watermark_img'); ?>" class="wt_preview_admin" ><br>
							<input id="woocommerce_watermark_img" name="woocommerce_watermark_img" type="text" size="36" value="<?php echo isset($immagine) ? $immagine : ''; ?>" />
							<input id="woocommerce_watermark_img_button" class="button-primary" name="woocommerce_watermark_img_button" type="button" value="<?php _e( 'Upload Image', 'nst' ); ?>" /> 
                            <span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="woocommerce_watermark_img_lg"><?php _e('Select a Watermark for thumbnail', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Select a image from your local folder or from media library', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <img src="<?php echo get_option('woocommerce_watermark_img_lg'); ?>" class="wt_preview_admin" ><br>
							<input id="woocommerce_watermark_img_lg" name="woocommerce_watermark_img_lg" type="text" size="36" value="<?php echo isset($immagine_lg) ? $immagine_lg : ''; ?>" />
							<input id="woocommerce_watermark_img_lg_button" class="button-primary" name="woocommerce_watermark_img_lg_button" type="button" value="<?php _e( 'Upload Image', 'nst' ); ?>" /> 
                            <span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="wt_position"><?php _e('Watermark Position', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Set watermark position', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <input type="hidden" name="wt_position" id="wt_position" value="<?php echo get_option('wt_position'); ?>">
							<div id="ns_square_container">
								<div class="ns_square" id="ns_square_1" data-square="1"></div>
								<div class="ns_square" id="ns_square_2" data-square="2"></div>
								<div class="ns_square" id="ns_square_3" data-square="3"></div>
								<div class="ns_square" id="ns_square_4" data-square="4"></div>
								<div class="ns_square" id="ns_square_5" data-square="5"></div>
								<div class="ns_square" id="ns_square_6" data-square="6"></div>
								<div class="ns_square" id="ns_square_7" data-square="7"></div>
								<div class="ns_square" id="ns_square_8" data-square="8"></div>
								<div class="ns_square" id="ns_square_9" data-square="9"></div>
							</div>
							<span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="wt_repeat"><?php _e('Watermark Repat', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('If select this option the Watermark Position it is ignored', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
							<?php $checked = (get_option('wt_repeat') AND get_option('wt_repeat') == 'on') ? ' checked="checked"' : ''; ?>
                            <input type="checkbox" name="wt_repeat" id="wt_repeat" <?php echo $checked; ?>>
							<span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="wt_margin"><?php _e('Watermark margin', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Margin from watermark to border', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <input type="text" name="wt_margin" id="wt_margin" value="<?php echo get_option('wt_margin'); ?>">
							<span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="wt_opacity"><?php _e('Background watermark opacity %', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Watermark background opacity. Set 0 to remove', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <input type="text" name="wt_opacity" id="wt_opacity" value="<?php echo get_option('wt_opacity'); ?>">
							<span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="wt_color_op"><?php _e('Background watermark<br>color', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Watermark background color opacity. Set Background watermark opacity 0 to remove', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <input type="text" name="wt_color_op" id="wt_color_op" value="<?php echo get_option('wt_color_op'); ?>">
							<span class="description"></span>
                        </td>
                    </tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="ly_opacity"><?php _e('Layer opacity %', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Layer opacity. Set 0 to remove', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
						<td class="forminp">
							<input type="text" name="ly_opacity" id="ly_opacity" value="<?php echo get_option('ly_opacity'); ?>">
							<span class="description"></span>
						</td>
						</tr>
					<tr valign="top">
						<th class="titledesc" scope="row">
							<label for="ly_color_op"><?php _e('Layer background color', 'ns-woocommerce-watermark-premium'); ?></label>
							<div class="ns-tooltip">?<span class="ns-tooltiptext"><?php _e('Layer background color. Set Layer opacity 0 to remove', 'ns-woocommerce-watermark-premium'); ?></span></div>
						</th>
                        <td class="forminp">
                            <input type="text" name="ly_color_op" id="ly_color_op" value="<?php echo get_option('ly_color_op'); ?>">
							<span class="description"></span>
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th class="titledesc" scope="row"></th>
						<td class="forminp">

						</td>
                    </tr>
                </tbody>
            </table>
			<p class="submit">
				<input type="submit" class="button-primary" id="submit" name="submit" value="<?php _e('Save Changes') ?>" />
			</p>
        </form>
    </div>
    <?php
}

?>