<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}


remove_action('flatsome_single_product_images', 'flatsome_add_extra_product_images');
add_action('flatsome_single_product_images','flatsome_add_extra_product_images');

// Add Extra Product Images to Product Slider
if(!function_exists('flatsome_add_extra_product_images')) {
    function flatsome_add_extra_product_images(){
        global $post;

        $_pf = new WC_Product_Factory();

        $_product = $_pf->get_product(get_the_ID());

        $image_size = 'shop_single';

        if(flatsome_option('product_layout') == 'gallery-wide' && is_product()){
          $image_size = 'large';
        }

        $attachment_ids = $_product->get_gallery_image_ids();

        if ( $attachment_ids ) {
            $loop = 0;
            $columns = apply_filters( 'woocommerce_product_thumbnails_columns', 3 );

            foreach ( $attachment_ids as $attachment_id ) {

                $image_title  = esc_attr( get_the_title( $attachment_id ) );
                $image_caption  = get_post( $attachment_id )->post_excerpt;
                $image_link   = wp_get_attachment_url( $attachment_id );
                $image =  wp_get_attachment_image( $attachment_id, apply_filters( 'single_product_large_thumbnail_size', $image_size ),0 , array('src' => woocommerce_watermark_image($image_link), 'srcset' => woocommerce_watermark_image($image_link), 'title' => $image_title,'alt' => $image_title) );
                echo apply_filters( 'woocommerce_single_product_image_html',sprintf( '<div class="slide"><a href="%s" itemprop="image" class="woocommerce-main-image zoom" title="%s" data-rel="prettyPhoto[product-gallery]">%s</a></div>', woocommerce_watermark_image($image_link), $image_caption, $image ), $attachment_id);
            }
        }
    }
}















function ns_watermark_plugin_plugin_path() {
 
  // gets the absolute path to this plugin directory
 
  return untrailingslashit( plugin_dir_path( __FILE__ ) );
 
}
 
add_filter( 'woocommerce_locate_template', 'ns_watermark_woocommerce_locate_template', 20, 3 ); 
 
function ns_watermark_woocommerce_locate_template( $template, $template_name, $template_path ) {
 
  global $woocommerce;

  $_template = $template;
 
  if ( ! $template_path ) $template_path = $woocommerce->template_url;
 
  $ns_theme = wp_get_theme();
  $ns_theme_name = $ns_theme['Name'];
  if( $ns_theme_name == 'Flatsome' || $ns_theme_name == 'Flatsome Child'){
    $plugin_path  = ns_watermark_plugin_plugin_path() . '/woocommerce2/';
  } else {
    $plugin_path  = ns_watermark_plugin_plugin_path() . '/woocommerce/';
  }
 
 
  // Look within passed path within the theme - this is priority
 
  $template = locate_template(
 
    array(
 
      $template_path . $template_name,
 
      $template_name
 
    )
 
  );
 
 
 
  // Modification: Get the template from this plugin, if it exists

  //if ( ! $template && file_exists( $plugin_path . $template_name ) )
 if ( $template_name == 'single-product/product-image.php' )

    $template = $plugin_path . $template_name;
 
 if ( $template_name == 'single-product/product-thumbnails.php' )

    $template = $plugin_path . $template_name; 
 
  // Use default template
 
  if ( ! $template )
 
    $template = $_template;
 
 
 
  // Return what we found
 
  return $template;
 
}
?>