<?php
/*
Plugin Name: NS WooCommerce Watermark premium
Plugin URI: http://www.nsthemes.com/product/woocommerce-watermark/
Description: Add a Watermark on woocommerce immage
Version: 2.3.0
Author: NsThemes
Author URI: http://nsthemes.com
License: GNU General Public License v2.0
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( ! defined( 'WATERMARK_NS_PLUGIN_DIR' ) )
    define( 'WATERMARK_NS_PLUGIN_DIR', untrailingslashit( dirname( __FILE__ ) ) );

if ( ! defined( 'WATERMARK_NS_WW_PLUGIN_DIR' ) )
    define( 'WATERMARK_NS_WW_PLUGIN_DIR', WP_PLUGIN_URL.'/ns-woocommerce-watermark-premium/' );

$ns_theme = wp_get_theme();
$ns_theme_name = $ns_theme['Name'];

/* *** include css *** */
function woocommerce_watermark_css( $hook ) {
	wp_enqueue_style('ns-style-watermark', WATERMARK_NS_WW_PLUGIN_DIR . '/css/style.css');
	wp_enqueue_style( 'wp-color-picker' );
}
add_action( 'admin_enqueue_scripts', 'woocommerce_watermark_css' );

function woocommerce_watermark_css_avada( $hook ) {
	wp_enqueue_style('ns-style-watermark-avada', WATERMARK_NS_WW_PLUGIN_DIR . '/css/custom-avada.css');
}
if( $ns_theme_name == 'Avada' || $ns_theme_name == 'Avada Child'){
	add_action( 'wp_enqueue_scripts', 'woocommerce_watermark_css_avada' );
}

/* *** include js *** */
function woocommerce_watermark_js( $hook ) {
	wp_enqueue_script('ns-custom-script-watermark', WATERMARK_NS_WW_PLUGIN_DIR . '/js/custom.js', array('jquery', 'wp-color-picker'));
	wp_enqueue_media();
}
add_action( 'admin_enqueue_scripts', 'woocommerce_watermark_js' );


/* *** include loop product watermark *** */
require_once( WATERMARK_NS_PLUGIN_DIR.'/woocommerce-watermark-loop.php');

/* *** include single product watermark *** */
require_once( WATERMARK_NS_PLUGIN_DIR.'/woocommerce-watermark-single-product.php');

/* *** include single product gallery watermark *** */
#require_once( WATERMARK_NS_PLUGIN_DIR.'/woocommerce-watermark-product-thumbnails.php');

/* *** include admin option *** */
require_once( WATERMARK_NS_PLUGIN_DIR.'/woocommerce-watermark-admin.php');



function ns_watermark_activate_set_default_options() {
	add_option('woocommerce_watermark_enabled_plugin', '0');
    add_option('woocommerce_watermark_img', WATERMARK_NS_WW_PLUGIN_DIR.'/img/logo-nsthemes-black.png');
    add_option('woocommerce_watermark_img_lg', WATERMARK_NS_WW_PLUGIN_DIR.'/img/logo-nsthemes-black.png');
    add_option('wt_position', '5');
    add_option('wt_repeat', '');
    add_option('wt_margin', '0');
    add_option('wt_opacity', '0');
    add_option('wt_color_op', '#000000');
    add_option('ly_opacity', '0');
    add_option('ly_color_op', '#000000');
}
 
register_activation_hook( __FILE__, 'ns_watermark_activate_set_default_options');



function woocommerce_watermark_image($image) {
	
	$current_user = wp_get_current_user();
	$not_user = (!isset($current_user->user_email) OR $current_user->user_email == '') ? true : false;
	
	if (get_option('woocommerce_watermark_enabled_plugin') == 0 OR (get_option('woocommerce_watermark_enabled_plugin') == 2 AND $not_user)) {
		$param_img = base64_encode('image_path='.$image.'&wt_path='.get_option('woocommerce_watermark_img').'&wt_position='.get_option('wt_position').'&wt_repeat='.get_option('wt_repeat').'&wt_margin='.get_option('wt_margin').'&wt_opacity='.get_option('wt_opacity').'&ly_opacity='.get_option('ly_opacity').'&ly_color_op='.get_option('ly_color_op').'&wt_color_op='.get_option('wt_color_op').'&wt_base_path='.plugin_dir_path( __FILE__ ));
		return WATERMARK_NS_WW_PLUGIN_DIR.'ns_image.php?param='.$param_img;
	} else {
		return $image;
	}
}

function woocommerce_watermark_image_lg($image) {
	$param_img = base64_encode('image_path='.$image.'&wt_path='.get_option('woocommerce_watermark_img_lg').'&wt_position='.get_option('wt_position').'&wt_repeat='.get_option('wt_repeat').'&wt_margin='.get_option('wt_margin').'&wt_opacity='.get_option('wt_opacity').'&ly_opacity='.get_option('ly_opacity').'&ly_color_op='.get_option('ly_color_op').'&wt_color_op='.get_option('wt_color_op').'&wt_base_path='.plugin_dir_path( __FILE__ ));
	return WATERMARK_NS_WW_PLUGIN_DIR.'ns_image.php?param='.$param_img;
}


function ns_woo_watermark_p_add_option_page() {
    add_menu_page('NS Watermark', 'NS Watermark', 'manage_options', 'ns-options-page-woo-watermark-p', 'ns_update_options_form', WATERMARK_NS_WW_PLUGIN_DIR.'/img/backend-sidebar-icon.png', 60);
}
 
add_action('admin_menu', 'ns_woo_watermark_p_add_option_page');


?>