<?php
/**
 * Light Gallery Premium Shortcode
 *
 * @access    public
 * @since     3.0
 *
 * @return    Create Fontend Slider Output
 */
add_shortcode('NPG', 'awl_photo_gallery_shortcode');
function awl_photo_gallery_shortcode($post_id) {
	ob_start();
	//js
	wp_enqueue_script('jquery');
	wp_enqueue_script('awl-lg-imagesloaded-js', LG_PLUGIN_URL .'js/imagesloaded.pkgd.js', array('jquery'), '' , true);
	wp_enqueue_script('awl-lg-isotope-js', LG_PLUGIN_URL .'js/isotope.pkgd.js', array('jquery'), '' , true);
	wp_enqueue_script('awl-lg-lightcase-js', LG_PLUGIN_URL .'js/lightcase.js', array('jquery'), '' , true);
	
	// awp custom bootstrap css
	wp_enqueue_style('awl-lg-bootstrap-css', LG_PLUGIN_URL .'css/lg-bootstrap.css');
	wp_enqueue_style('awl-lg-lightcase-css', LG_PLUGIN_URL.'css/lightcase.css' );
	
	$gallery_settings = unserialize(base64_decode(get_post_meta( $post_id['id'], 'awl_lg_settings_'.$post_id['id'], true)));
	//print_r($gallery_settings);
	
	$light_image_gallery_id = $post_id['id'];
	
	//columns settings	
	$gal_thumb_size = $gallery_settings['gal_thumb_size'];
	$col_large_desktops = $gallery_settings['col_large_desktops'];
	$col_desktops = $gallery_settings['col_desktops'];
	$col_tablets = $gallery_settings['col_tablets'];
	$col_phones = $gallery_settings['col_phones'];
	
	// ligtbox style
	if(isset($gallery_settings['light-box'])) $light_box = $gallery_settings['light-box']; else $light_box = 1;
	
	// transition Effect
	if(isset($gallery_settings['transition_effects'])) $transition_effects = $gallery_settings['transition_effects']; else $transition_effects = "";
	if($transition_effects == "none"){
		echo "";
	} else {
		// transition effects css
		wp_enqueue_style('awl-lg-transitions-css', LG_PLUGIN_URL . 'lightbox/light-gallery/css/lg-transitions.css');
	}
	if($transition_effects == "2d")
		if(isset($gallery_settings['transition_effects'])) $transition_effects = $gallery_settings['transition_effects']; else $transition_effects = "hvr-buzz";
	
	
	//hover effect
	if(isset($gallery_settings['image_hover_effect_type'])) $image_hover_effect_type = $gallery_settings['image_hover_effect_type']; else $image_hover_effect_type = "2d";
	if($image_hover_effect_type == "no") {
		$image_hover_effect = "";
	} else {
		// hover csss
		wp_enqueue_style('lg-hover-css', LG_PLUGIN_URL .'css/hover.css');
	}
	
	if($image_hover_effect_type == "2d")
		if(isset($gallery_settings['image_hover_effect_one'])) $image_hover_effect = $gallery_settings['image_hover_effect_one']; else $image_hover_effect = "hvr-buzz";
	if($image_hover_effect_type == "bg")
		if(isset($gallery_settings['image-hover-effect-2'])) $image_hover_effect = $gallery_settings['image-hover-effect-2']; else $image_hover_effect = "hvr-bounce-to-top";
	if($image_hover_effect_type == "br")
		if(isset($gallery_settings['image-hover-effect-3'])) $image_hover_effect = $gallery_settings['image-hover-effect-3']; else $image_hover_effect = "hvr-ripple-out";
	if($image_hover_effect_type == "sg")
		if(isset($gallery_settings['image_hover_effect_four'])) $image_hover_effect = $gallery_settings['image_hover_effect_four']; else $image_hover_effect = "hvr-box-shadow-outset";
	if($image_hover_effect_type == "cl")
		if(isset($gallery_settings['image-hover-effect-5'])) $image_hover_effect = $gallery_settings['image-hover-effect-5']; else $image_hover_effect = "hvr-curl-top-left";
	
	//start fix lightbox settings
	if(isset($gallery_settings['pg_lightbox_style'])) $pg_lightbox_style = $gallery_settings['pg_lightbox_style']; else $pg_lightbox_style = "light_lightbox";
	if(isset($gallery_settings['lightbox_width'])) $lightbox_width = $gallery_settings['lightbox_width']; else $lightbox_width = 853;
	if(isset($gallery_settings['lightbox_height'])) $lightbox_height = $gallery_settings['lightbox_height']; else $lightbox_height = 480;
	//end fix lightbox settings
	
	//light gallery & fixed Size Lightbox Settings
	if(isset($gallery_settings['title_hide_show'])) $title_hide_show = $gallery_settings['title_hide_show']; else $title_hide_show = "hide";
	if(isset($gallery_settings['image_title_color'])) $image_title_color = $gallery_settings['image_title_color']; else $image_title_color = "black";
	if(isset($gallery_settings['title_color'])) $title_color = $gallery_settings['title_color']; else $title_color = "white";
	if(isset($gallery_settings['tool_color'])) $tool_color = $gallery_settings['tool_color']; else $tool_color = "#ffffff";
	if(isset($gallery_settings['thumb_hide_show'])) $thumb_hide_show = $gallery_settings['thumb_hide_show']; else $thumb_hide_show = "false";
	if(isset($gallery_settings['lightbox_speed'])) $lightbox_speed = $gallery_settings['lightbox_speed']; else $lightbox_speed = 500;
	if(isset($gallery_settings['transition_effects'])) $transition_effects = $gallery_settings['transition_effects']; else $transition_effects = "none";
	if(isset($gallery_settings['lightbox_drag_image'])) $lightbox_drag_image = $gallery_settings['lightbox_drag_image']; else $lightbox_drag_image = "true";
	if(isset($gallery_settings['download_icon_hide_show'])) $download_icon_hide_show = $gallery_settings['download_icon_hide_show']; else $download_icon_hide_show = "true";
	if(isset($gallery_settings['lightbox_image_count'])) $lightbox_image_count = $gallery_settings['lightbox_image_count']; else $lightbox_image_count = "true";
	if(isset($gallery_settings['lightbox_autoplay_icon'])) $lightbox_autoplay_icon = $gallery_settings['lightbox_autoplay_icon']; else $lightbox_autoplay_icon = "true";
	if(isset($gallery_settings['lightbox_fullscreen_icon'])) $lightbox_fullscreen_icon = $gallery_settings['lightbox_fullscreen_icon']; else $lightbox_fullscreen_icon = "true";
	if(isset($gallery_settings['lightbox_zoom_icon'])) $lightbox_zoom_icon = $gallery_settings['lightbox_zoom_icon']; else $lightbox_zoom_icon = "true";
	if(isset($gallery_settings['lightbox_actualsize_icon'])) $lightbox_actualsize_icon = $gallery_settings['lightbox_actualsize_icon']; else $lightbox_actualsize_icon = "true";
	if(isset($gallery_settings['events_settings'])) $events_settings = $gallery_settings['events_settings']; else $events_settings = "false";
	//if(isset($gallery_settings['fix_lightbox'])) $fix_lightbox = $gallery_settings['fix_lightbox']; else $fix_lightbox = "false";
	if(isset($gallery_settings['thumbnails_spacing'])) $thumbnails_spacing = $gallery_settings['thumbnails_spacing']; else $thumbnails_spacing = 1;
	if(isset($gallery_settings['events_settings'])) $events_settings = $gallery_settings['events_settings']; else $events_settings = "false";
	if(isset($gallery_settings['custom-css'])) $custom_css = $gallery_settings['custom-css']; else $custom_css = "";
	if(isset($gallery_settings['thumbnail_order'])) $thumbnail_order = $gallery_settings['thumbnail_order']; else $thumbnail_order = "ASC";
	
	//lightcase lightbox
	if(isset($gallery_settings['lightcase_effects'])) $lightcase_effects = $gallery_settings['lightcase_effects']; else $lightcase_effects = "none";
	if(isset($gallery_settings['lightcase_color'])) $lightcase_color = $gallery_settings['lightcase_color']; else $lightcase_color = "#ffffff";
	if(isset($gallery_settings['lightcase_opacity'])) $lightcase_opacity = $gallery_settings['lightcase_opacity']; else $lightcase_opacity = 0.3;
	if(isset($gallery_settings['lightcase_bg_color'])) $lightcase_bg_color = $gallery_settings['lightcase_bg_color']; else $lightcase_bg_color = "#474747";
	if(isset($gallery_settings['lightcase_image_count'])) $lightcase_image_count = $gallery_settings['lightcase_image_count']; else $lightcase_image_count = "true";
	if(isset($gallery_settings['lightcase_title'])) $lightcase_title = $gallery_settings['lightcase_title']; else $lightcase_title = "true";
	if(isset($gallery_settings['lightcase_title_color'])) $lightcase_title_color = $gallery_settings['lightcase_title_color']; else $lightcase_title_color = "#999999";
	if(isset($gallery_settings['lightcase_font_size'])) $lightcase_font_size = $gallery_settings['lightcase_font_size']; else $lightcase_font_size = 12;
	?>
	<!-- CSS Part Start From Here-->
	<style>
		.photo_gallery_title {
			color: <?php echo $image_title_color; ?>;
		}
		#animated-thumbnials-<?php echo $light_image_gallery_id; ?> a {
			text-decoration: none !important;
			box-shadow: 0 0px 0 0 currentcolor !important;
		}
		<?php if($thumbnails_spacing == 0) { ?>
			#animated-thumbnials-<?php echo $light_image_gallery_id; ?> .thumbnail {
				border: 0px !important;
				border-radius: 0px !important;
				display: block;
				line-height: 1.42857;
				margin-bottom: 0px !important;
				padding: 0px !important;
			}
			#animated-thumbnials-<?php echo $light_image_gallery_id; ?> img {
				width: 100% !important;
			}
			
			#animated-thumbnials-<?php echo $light_image_gallery_id; ?> .col-xs-1, .col-sm-1, .col-md-1, .col-lg-1, .col-xs-2, .col-sm-2, .col-md-2, .col-lg-2, .col-xs-3, .col-sm-3, .col-md-3, .col-lg-3, .col-xs-4, .col-sm-4, .col-md-4, .col-lg-4, .col-xs-5, .col-sm-5, .col-md-5, .col-lg-5, .col-xs-6, .col-sm-6, .col-md-6, .col-lg-6, .col-xs-7, .col-sm-7, .col-md-7, .col-lg-7, .col-xs-8, .col-sm-8, .col-md-8, .col-lg-8, .col-xs-9, .col-sm-9, .col-md-9, .col-lg-9, .col-xs-10, .col-sm-10, .col-md-10, .col-lg-10, .col-xs-11, .col-sm-11, .col-md-11, .col-lg-11, .col-xs-12, .col-sm-12, .col-md-12, .col-lg-12 {
				padding-left: 0px !important;
				padding-right: 0px !important;
			}
		<?php } ?>
			.lg-icon {
				color : <?php echo $tool_color; ?> !important;
			}
			.pg-titile {
				color: <?php echo $title_color; ?> !important;
			}
		
		<?php echo $custom_css; ?>
		
		[class*="lightcase-icon-"]::before {
			border-radius: 50%;
			color: <?php echo $lightcase_color; ?> !important;
		}
		#lightcase-overlay {
			 opacity: <?php echo $lightcase_opacity; ?> !important;
			 background-color: <?php echo $lightcase_bg_color; ?> !important;
		}
		#lightcase-info #lightcase-caption {
			color: <?php echo $lightcase_title_color; ?> !important;
			font-size: <?php echo $lightcase_font_size; ?>px !important;
		}
		#lightcase-info #lightcase-sequenceInfo {
			color: <?php echo $lightcase_title_color; ?> !important;
			font-size: <?php echo $lightcase_font_size; ?>px;
		}
	</style>
	<?php
	require('thumbnail.php');
	return ob_get_clean();
}
?>